//**********************
// RS232C Function
//
// (C)Copyright 2009 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************
//#if defined(__dsPIC30F__)
//#include <p30fxxxx.h>
//#elif defined(__dsPIC33F__)
//#include <p33Fxxxx.h>
//#elif defined(__PIC24H__)
//#include <p24Hxxxx.h>
//#elif defined(__PIC24F__)
//#include <p24Fxxxx.h>
//#endif
#include <uart.h>
#ifndef UART_ALTRX_ALTTX
#define UART_ALTRX_ALTTX 0xFFE7
#endif

//**********************
// FOSC, PLL, FCY
//**********************
#if defined(__dsPIC30F__)
#define	FOSC	7372800UL
#define	PLL	16
#define	FCY	FOSC*PLL/4
#else
#define	FOSC	8000000UL
#define	PLL	1
#define	FCY	FOSC*PLL/2
#endif

//**********************
// BaudRate
//**********************
//#define BaudRate 1200
//#define BaudRate 1800
//#define BaudRate 2400
//#define BaudRate 4800
#define BaudRate 9600
//#define BaudRate 19200
//#define BaudRate 38400
//#define BaudRate 57600
//#define BaudRate 115200
//#define BaudRate 230400
//#define BaudRate 460800

unsigned int _U1BRG;
unsigned int _U1MODE;
unsigned int _U1STA;
#ifdef _U2RXIF
unsigned int _U2BRG;
unsigned int _U2MODE;
unsigned int _U2STA;
#endif

void OpenCOM1(void)
{
	// Trun off UART1
	CloseUART1();
	// Configure UART1 interrupt
	ConfigIntUART1(	UART_RX_INT_DIS &
					UART_TX_INT_DIS);
	// Configure UART1
	// U1BRG=((Fcy/BaudRate)/16)-1
	//      =((29491200/19200)/16)-1
	//      =95
	// BaudRate=Fcy/(16(U1BRG+1))
	//         =29491200/(16(95+1))
	//         =19200
	// Error=(19200-19200)/19200
	//      =0%
	_U1BRG=	((FCY/BaudRate)/16)-1;
#if defined(__dsPIC30F__)
	_U1MODE=	UART_EN &
//				UART_DIS &

				UART_IDLE_CON &
//				UART_IDLE_STOP &

				UART_ALTRX_ALTTX &
//				UART_RX_TX &

//				UART_EN_WAKE &
				UART_DIS_WAKE &

//				UART_EN_LOOPBACK &
				UART_DIS_LOOPBACK &

				UART_EN_ABAUD &
//				UART_DIS_ABAUD &

//				UART_NO_PAR_9BIT &
//				UART_ODD_PAR_8BIT &
//				UART_EVEN_PAR_8BIT &
				UART_NO_PAR_8BIT &

//				UART_2STOPBITS &
				UART_1STOPBIT;
	_U1STA=		UART_INT_TX_BUF_EMPTY &
//				UART_INT_TX &

				UART_TX_PIN_NORMAL &
//				UART_TX_PIN_LOW &

				UART_TX_ENABLE &
//				UART_TX_DISABLE &

//				UART_INT_RX_BUF_FUL &
//				UART_INT_RX_3_4_FUL &
				UART_INT_RX_CHAR &

//				UART_ADR_DETECT_EN &
				UART_ADR_DETECT_DIS &

				UART_RX_OVERRUN_CLEAR;
#else
	_U1MODE=	UART_EN &
//				UART_DIS &

				UART_IDLE_CON &
//				UART_IDLE_STOP &

//				UART_IrDA_ENABLE &
				UART_IrDA_DISABLE &

//				UART_MODE_SIMPLEX &
				UART_MODE_FLOW &

//				UART_UEN_11 &
//				UART_UEN_10 &
//				UART_UEN_01 &
				UART_UEN_00 &

//				UART_EN_WAKE &
				UART_DIS_WAKE &

//				UART_EN_LOOPBACK &
				UART_DIS_LOOPBACK &

//				UART_EN_ABAUD &
				UART_DIS_ABAUD &

//				UART_UXRX_IDLE_ZERO &
				UART_UXRX_IDLE_ONE &

//				UART_BRGH_FOUR &
				UART_BRGH_SIXTEEN &

//				UART_NO_PAR_9BIT &
//				UART_ODD_PAR_8BIT &
//				UART_EVEN_PAR_8BIT &
				UART_NO_PAR_8BIT &

//				UART_2STOPBITS &
				UART_1STOPBIT;

	_U1STA=		UART_INT_TX_BUF_EMPTY &
//				UART_INT_TX_LAST_CH &
//				UART_INT_TX &

//				UART_IrDA_POL_INV_ONE &
				UART_IrDA_POL_INV_ZERO &

//				UART_SYNC_BREAK_ENABLED &
				UART_SYNC_BREAK_DISABLED &

				UART_TX_ENABLE &
//				UART_TX_DISABLE &

//				UART_TX_BUF_FUL &
				UART_TX_BUF_NOT_FUL &

//				UART_INT_RX_BUF_FUL &
//				UART_INT_RX_3_4_FUL &
				UART_INT_RX_CHAR &

//				UART_ADR_DETECT_EN &
				UART_ADR_DETECT_DIS &

				UART_RX_OVERRUN_CLEAR;
#endif
	// Open UART1
	OpenUART1(_U1MODE, _U1STA, _U1BRG);

}


void PutcCOM1(unsigned int a)
{
	WriteUART1(a);
	while(!U1STAbits.TRMT);
}


unsigned int GetcCOM1(void)
{
	while(U1STAbits.URXDA==0);	// wait RX data
	return ReadUART1();
}


void PutsCOM1(unsigned int *a)
{
	putsUART1(a);
	while(!U1STAbits.TRMT);
}


unsigned int GetsCOM1(unsigned int l, unsigned int *a)
{
	return getsUART1(l, a, 0x7FFF);
}


#ifdef _U2RXIF

void OpenCOM2(void)
{
	// Trun off UART2
	CloseUART2();
	// Configure UART2 interrupt
	ConfigIntUART2(	UART_RX_INT_DIS &
					UART_TX_INT_DIS);
	// Configure UART2
	_U2BRG=	((FCY/BaudRate)/16)-1;
#if defined(__dsPIC30F__)
	_U2MODE=	UART_EN &
//				UART_DIS &

				UART_IDLE_CON &
//				UART_IDLE_STOP &

				UART_ALTRX_ALTTX &
//				UART_RX_TX &

//				UART_EN_WAKE &
				UART_DIS_WAKE &

//				UART_EN_LOOPBACK &
				UART_DIS_LOOPBACK &

				UART_EN_ABAUD &
//				UART_DIS_ABAUD &

//				UART_NO_PAR_9BIT &
//				UART_ODD_PAR_8BIT &
//				UART_EVEN_PAR_8BIT &
				UART_NO_PAR_8BIT &

//				UART_2STOPBITS &
				UART_1STOPBIT;
	_U2STA=		UART_INT_TX_BUF_EMPTY &
//				UART_INT_TX &

				UART_TX_PIN_NORMAL &
//				UART_TX_PIN_LOW &

				UART_TX_ENABLE &
//				UART_TX_DISABLE &

//				UART_INT_RX_BUF_FUL &
//				UART_INT_RX_3_4_FUL &
				UART_INT_RX_CHAR &

//				UART_ADR_DETECT_EN &
				UART_ADR_DETECT_DIS &

				UART_RX_OVERRUN_CLEAR;
#else
	_U2MODE=	UART_EN &
//				UART_DIS &

				UART_IDLE_CON &
//				UART_IDLE_STOP &

//				UART_IrDA_ENABLE &
				UART_IrDA_DISABLE &

//				UART_MODE_SIMPLEX &
				UART_MODE_FLOW &

//				UART_UEN_11 &
//				UART_UEN_10 &
//				UART_UEN_01 &
				UART_UEN_00 &

//				UART_EN_WAKE &
				UART_DIS_WAKE &

//				UART_EN_LOOPBACK &
				UART_DIS_LOOPBACK &

//				UART_EN_ABAUD &
				UART_DIS_ABAUD &

//				UART_UXRX_IDLE_ZERO &
				UART_UXRX_IDLE_ONE &

//				UART_BRGH_FOUR &
				UART_BRGH_SIXTEEN &

//				UART_NO_PAR_9BIT &
//				UART_ODD_PAR_8BIT &
//				UART_EVEN_PAR_8BIT &
				UART_NO_PAR_8BIT &

//				UART_2STOPBITS &
				UART_1STOPBIT;

	_U2STA=		UART_INT_TX_BUF_EMPTY &
//				UART_INT_TX_LAST_CH &
//				UART_INT_TX &

//				UART_IrDA_POL_INV_ONE &
				UART_IrDA_POL_INV_ZERO &

//				UART_SYNC_BREAK_ENABLED &
				UART_SYNC_BREAK_DISABLED &

				UART_TX_ENABLE &
//				UART_TX_DISABLE &

//				UART_TX_BUF_FUL &
				UART_TX_BUF_NOT_FUL &

//				UART_INT_RX_BUF_FUL &
//				UART_INT_RX_3_4_FUL &
				UART_INT_RX_CHAR &

//				UART_ADR_DETECT_EN &
				UART_ADR_DETECT_DIS &

				UART_RX_OVERRUN_CLEAR;
#endif
	// Open UART2
	OpenUART2(_U2MODE, _U2STA, _U2BRG);

}


void PutcCOM2(unsigned int a)
{
	WriteUART2(a);
	while(!U2STAbits.TRMT);
}


unsigned int GetcCOM2(void)
{
	while(U2STAbits.URXDA==0);	// wait RX data
	return ReadUART2();
}


void PutsCOM2(unsigned int *a)
{
	putsUART2(a);
	while(!U2STAbits.TRMT);
}


unsigned int GetsCOM2(unsigned int l, unsigned int *a)
{
	return getsUART2(l, a, 0x7FFF);
}


#endif

